JUCE: misc

JUCE

Classes | Typedefs | Functions
misc
juce_core

## Classes
struct | ArgumentList
| Holds a list of command-line arguments, and provides useful methods for searching and operating on them. More...
struct | ArgumentList::Argument
| One of the arguments in an ArgumentList. More...
struct | ConsoleApplication
| Represents a the set of commands that a console app can perform, and provides helper functions for performing them. More...
struct | ConsoleApplication::Command
| Represents a command that can be executed if its command-line arguments are matched. More...
struct | NullCheckedInvocation
| Some helper methods for checking a callable object before invoking with the specified arguments. More...
class | Result
| Represents the 'success' or 'failure' of an operation, and holds an associated error message to describe the error when there's a failure. More...
class | RuntimePermissions
class | Uuid
| A universally unique 128-bit identifier. More...
class | WindowsRegistry
| Contains some static helper functions for manipulating the MS Windows registry (Only available on Windows, of course!) More...

## Typedefs
template<typename A , typename B >
using | DisableIfSameOrDerived = typename std::enable_if_t<! std::is_base_of< A, std::remove_reference_t< B > >::value >
| Can be used to disable template constructors that would otherwise cause ambiguity with compiler-generated copy and move constructors. More...

## Functions
template<typename Object , typename OtherObject , typename Member >
Object | withMember (Object copy, Member OtherObject::*member, Member &&value)
| Copies an object, sets one of the copy's members to the specified value, and then returns the copy. More...

## Detailed Description

## Typedef Documentation

## ◆ DisableIfSameOrDerived

template<typename A , typename B >

using DisableIfSameOrDerived = typename std::enable_if_t<! std::is_base_of<A, std::remove_reference_t<B> >::value>

Can be used to disable template constructors that would otherwise cause ambiguity with compiler-generated copy and move constructors.

Adapted from https://ericniebler.com/2013/08/07/universal-references-and-the-copy-constructo/

## Function Documentation

## ◆ withMember()

template<typename Object , typename OtherObject , typename Member >

Object withMember | ( | Object | copy,
|  | Member OtherObject::* | member,
|  | Member && | value
| ) |  |

Copies an object, sets one of the copy's members to the specified value, and then returns the copy.

References StandardApplicationCommandIDs::copy, and gl::value.

Referenced by AudioProcessorParameterWithIDAttributes::withAutomatable(), AudioProcessorValueTreeStateParameterAttributes::withAutomatable(), RangedAudioParameterAttributes< Derived, Value >::withAutomatable(), AudioProcessorValueTreeStateParameterAttributes::withBoolean(), AudioProcessorParameterWithIDAttributes::withCategory(), AudioProcessorValueTreeStateParameterAttributes::withCategory(), RangedAudioParameterAttributes< Derived, Value >::withCategory(), AudioProcessorValueTreeStateParameterAttributes::withDiscrete(), AudioProcessorParameterWithIDAttributes::withInverted(), AudioProcessorValueTreeStateParameterAttributes::withInverted(), RangedAudioParameterAttributes< Derived, Value >::withInverted(), AudioProcessorParameterWithIDAttributes::withLabel(), AudioProcessorValueTreeStateParameterAttributes::withLabel(), RangedAudioParameterAttributes< Derived, Value >::withLabel(), AudioProcessorParameterWithIDAttributes::withMeta(), AudioProcessorValueTreeStateParameterAttributes::withMeta(), RangedAudioParameterAttributes< Derived, Value >::withMeta(), AudioProcessorValueTreeStateParameterAttributes::withStringFromValueFunction(), RangedAudioParameterAttributes< Derived, Value >::withStringFromValueFunction(), AudioProcessorValueTreeStateParameterAttributes::withValueFromStringFunction(), and RangedAudioParameterAttributes< Derived, Value >::withValueFromStringFunction().